<?php
declare(strict_types=1);

namespace FiloBlu\Core\Api;

use Magento\Framework\Api\SearchCriteriaInterface;

interface FbOrderExtensionAttrRepositoryInterface
{

    /**
     * Save FbOrderExtensionAttr
     * @param \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface $fbOrderExtensionAttr
     * @return \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function save(
        \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface $fbOrderExtensionAttr
    );

    /**
     * Retrieve FbOrderExtensionAttr
     * @param string $fborderextensionattrId
     * @return \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function get($fborderextensionattrId);

    /**
     * Retrieve FbOrderExtensionAttr matching the specified criteria.
     * @param \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
     * @return \FiloBlu\Core\Api\Data\FbOrderExtensionAttrSearchResultsInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getList(
        \Magento\Framework\Api\SearchCriteriaInterface $searchCriteria
    );

    /**
     * Retrieve FbOrderExtensionAttr by order_id
     * @param string $fborderextensionattrId
     * @return \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function getByOrderId($order_id);

    /**
     * Delete FbOrderExtensionAttr
     * @param \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface $fbOrderExtensionAttr
     * @return bool true on success
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function delete(
        \FiloBlu\Core\Api\Data\FbOrderExtensionAttrInterface $fbOrderExtensionAttr
    );

    /**
     * Delete FbOrderExtensionAttr by ID
     * @param string $fborderextensionattrId
     * @return bool true on success
     * @throws \Magento\Framework\Exception\NoSuchEntityException
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function deleteById($fborderextensionattrId);
}

